//
// main.c
//
//  Created on: 2019/02/23
//      Author: ke-ta
//
// \home\C8051s\Core8051s_SW_DesignTutorial_DF\Core8051s_Software_Design_Tutorial_Files_V0.0\M1AFS-DEV-KIT-SCS\Tutorial_Files
//
#ifndef __REG51_H__
#define __REG51_H__

/*  BYTE Registers  */
sfr SP   = 0x81;
sfr DPL  = 0x82;
sfr DPH  = 0x83;
sfr DPL1 = 0x84;
sfr DPH1 = 0x85;
sfr DPS  = 0x92;
sfr XWB1 = 0x9A;
sfr XWB2 = 0x9B;
sfr XWB3 = 0x9C;
sfr XRB1 = 0x9D;
sfr XRB2 = 0x9E;
sfr XRB3 = 0x9F;
sfr PSW  = 0xD0;
sfr ACC  = 0xE0;
sfr B    = 0xF0;

/*  BIT Register  */
/*  PSW   */
sbit CY   = 0xD7;
sbit AC   = 0xD6;
sbit F0   = 0xD5;
sbit RS1  = 0xD4;
sbit RS0  = 0xD3;
sbit OV   = 0xD2;
sbit P    = 0xD0;

#endif


#ifndef CORE51S_P1_IO_H_
#define CORE51S_P1_IO_H_

#define base_wdt	((0x100 *  0) + 0xF000)
#define base_uart	((0x100 *  1) + 0xF000)
#define base_GPIO	((0x100 *  2) + 0xF000)
#define	base_pwm	((0x100 *  3) + 0xF000)


// CoreUARTapb memory map:
__xdata volatile at	base_uart+ 0x00 unsigned char TxData;
__xdata volatile at	base_uart+ 0x04 unsigned char RxData;
__xdata volatile at	base_uart+ 0x08 unsigned char Scon1;
__xdata volatile at	base_uart+ 0x0C unsigned char Scon2;
__xdata volatile at	base_uart+ 0x10 unsigned char SStat;

// CorePWM
__xdata volatile at	base_pwm + 0x00 unsigned char PRESCALE;
__xdata volatile at	base_pwm + 0x04 unsigned char PERIOD;
__xdata volatile at	base_pwm + 0x08 unsigned char PWM_ENABLE_0_7;
__xdata volatile at	base_pwm + 0x10 unsigned char PWM1_POSEDGE;
__xdata volatile at	base_pwm + 0x14 unsigned char PWM1_NEGEDGE;

// CoreGPIO
__xdata volatile at	base_GPIO+ 0xA0 unsigned char dataOut;
__xdata volatile at	base_GPIO+ 0x00 unsigned char dataIn;

#endif /*CORE51S_P1_IO_H_*/

void write_uart (char c)
{
	while (!( SStat  & 0x01));			/* wait until transmitter ready */
	TxData = c;      					/* output character */
	return;
}

char receive_uart (char* c)
{
	*c = RxData;						/* output character */
	return ((SStat & 0x02) >> 1);		/* output status */
}

char _getkey (void)
{
	char c;

	while (!(SStat & 0x02));			/* wait wait for a character */
	c =  RxData;						/* read the char */
	return (c);
}

void delay(unsigned long t)
{
	while(t--)
	{};
}

void main(void)
{
	int i = 0;
	char cc;

	// UART
	write_uart('H');
	write_uart('e');
	write_uart('l');
	write_uart('l');
	write_uart('o');
	write_uart('\r');
	write_uart('\n');

	for(;;)
	{
		// Flag
		if(i == 0)
		{
			i = 1;
		}
		else
		{
			i = 0;
		}

		// GPIO
		dataOut = i;

		// UART
		//receive_uart(&cc);
		cc = _getkey();
		write_uart(cc);
		write_uart('\r');
		write_uart('\n');

		delay(10000);
	}
}

